Index: sasmodels/models/raspberry.py
===================================================================
--- sasmodels/models/raspberry.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/raspberry.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -161,5 +161,5 @@
 
 source = ["lib/sas_3j1x_x.c", "raspberry.c"]
-effective_radius_type = ["radius_large", "radius_outer"]
+radius_effective_modes = ["radius_large", "radius_outer"]
 
 def random():
Index: sasmodels/models/rectangular_prism.c
===================================================================
--- sasmodels/models/rectangular_prism.c	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/rectangular_prism.c	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -14,5 +14,5 @@
 
 static double
-effective_radius(int mode, double length_a, double b2a_ratio, double c2a_ratio)
+radius_effective(int mode, double length_a, double b2a_ratio, double c2a_ratio)
 {
     switch (mode) {
Index: sasmodels/models/rectangular_prism.py
===================================================================
--- sasmodels/models/rectangular_prism.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/rectangular_prism.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -110,7 +110,7 @@
 ----------------------------
 
-* **Author:** 
-* **Last Modified by:** 
-* **Last Reviewed by:** 
+* **Author:**
+* **Last Modified by:**
+* **Last Reviewed by:**
 * **Source added by :** Steve King **Date:** March 25, 2019
 """
@@ -151,5 +151,5 @@
 source = ["lib/gauss76.c", "rectangular_prism.c"]
 have_Fq = True
-effective_radius_type = [
+radius_effective_modes = [
     "equivalent cylinder excluded volume", "equivalent volume sphere",
     "half length_a", "half length_b", "half length_c",
Index: sasmodels/models/sphere.c
===================================================================
--- sasmodels/models/sphere.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
+++ sasmodels/models/sphere.c	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -5,5 +5,5 @@
 
 static double
-effective_radius(int mode, double radius)
+radius_effective(int mode, double radius)
 {
     // case 1: radius
Index: sasmodels/models/sphere.py
===================================================================
--- sasmodels/models/sphere.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/sphere.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -49,6 +49,6 @@
 ----------------------------
 
-* **Author:** 
-* **Last Modified by:** 
+* **Author:**
+* **Last Modified by:**
 * **Last Reviewed by:** S King and P Parker **Date:** 2013/09/09 and 2014/01/06
 * **Source added by :** Steve King **Date:** March 25, 2019
@@ -81,5 +81,5 @@
 source = ["lib/sas_3j1x_x.c", "sphere.c"]
 have_Fq = True
-effective_radius_type = ["radius"]
+radius_effective_modes = ["radius"]
 
 def random():
@@ -92,10 +92,44 @@
 
 tests = [
-    [{}, 0.2, 0.726362],
-    [{"scale": 1., "background": 0., "sld": 6., "sld_solvent": 1.,
-      "radius": 120., "radius_pd": 0.2, "radius_pd_n":45},
-     0.2, 0.228843],
-    [{"radius": 120., "radius_pd": 0.2, "radius_pd_n":45},
-     0.1, None, None, 120., None, 1.0],
-    [{"@S": "hardsphere"}, 0.1, None],
+     [{}, 0.2, 0.726362], # each test starts with default parameter values inside { }, unless modified. Then Q and expected value of I(Q)
+     [{"scale": 1., "background": 0., "sld": 6., "sld_solvent": 1.,
+       "radius": 120., "radius_pd": 0.2, "radius_pd_n":45},
+      0.2, 0.2288431],
+    [{"radius": 120., "radius_pd": 0.02, "radius_pd_n":45},
+      0.2, 792.0646662454202, 1166737.0473152, 120.0, 7246723.820358589, 1.0], # the longer list here checks  F1, F2, R_eff, volume, volume_ratio = call_Fq(kernel, pars)
+   #  But note P(Q) = F2/volume
+   #  F and F^2 are "unscaled", with for  n <F F*>S(q) or for beta approx I(q) = n [<F F*> + <F><F*> (S(q) - 1)]
+   #  for n the number density and <.> the orientation average, and F = integral rho(r) exp(i q . r) dr.
+   #  The number density is volume fraction divided by particle volume.
+   #  Effectively, this leaves F = V drho form, where form is the usual 3 j1(qr)/(qr) or whatever depending on the shape.
+   # [{"@S": "hardsphere"},
+   #    0.01, 55.881884232102124], # this is current value, not verified elsewhere yet
+   # [{"radius": 120., "radius_pd": 0.2, "radius_pd_n":45},
+   #   0.2, 1.233304061, [1850806.119736], 120.0, 8087664.1226, 1.0], # the longer list here checks  F1, F2, R_eff, volume, volume_ratio = call_Fq(kernel, pars)
+   # [{"@S": "hardsphere"},
+   #     0.2, 0.14730859242492958], #  this is current value, not verified elsewhere yet
+    # [{"@S": "hardsphere"},
+    #    0.1, 0.7940350343811906], #  this is current value, not verified elsewhere yet
+    [{"@S": "hardsphere",
+     "radius": 120., "radius_pd": 0.2, "radius_pd_n":45,
+     "volfraction":0.2,
+     "radius_effective":45.0,     # uses this (check)
+     "structure_factor_mode": 1,  # 0 = normal decoupling approximation, 1 = beta(Q) approx
+     "radius_effective_mode": 0   # equivalent sphere, there is only one valid mode for sphere. says -this used r_eff =0 or default 50?
+     }, 0.01, 1316.2990966463444 ],
+    [{"@S": "hardsphere",
+     "radius": 120., "radius_pd": 0.2, "radius_pd_n":45,
+     "volfraction":0.2,
+     "radius_effective":50.0,        # hard sphere structure factor
+     "structure_factor_mode": 1,  # 0 = normal decoupling approximation, 1 = beta(Q) approx
+     "radius_effective_mode": 0   # this used r_eff =0 or default 50?
+     }, 0.01, 1324.7375636587356 ],
+    [{"@S": "hardsphere",
+     "radius": 120., "radius_pd": 0.2, "radius_pd_n":45,
+     "volfraction":0.2,
+     "radius_effective":50.0,        # hard sphere structure factor
+     "structure_factor_mode": 1,  # 0 = normal decoupling approximation, 1 = beta(Q) approx
+     "radius_effective_mode": 1   # this used 120 ???
+     }, 0.01, 1579.2858949296565 ]
 ]
+# putting None for expected result will pass the test if there are no errors from the routine, but without any check on the value of the result
Index: sasmodels/models/spherical_sld.c
===================================================================
--- sasmodels/models/spherical_sld.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
+++ sasmodels/models/spherical_sld.c	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -19,5 +19,5 @@
 
 static double
-effective_radius(int mode, double fp_n_shells, double thickness[], double interface[])
+radius_effective(int mode, double fp_n_shells, double thickness[], double interface[])
 {
     // case 1: outer radius
Index: sasmodels/models/spherical_sld.py
===================================================================
--- sasmodels/models/spherical_sld.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/spherical_sld.py	(revision 627b68ba23ef354dd8256c6325ff76a9c070c252)
@@ -18,4 +18,8 @@
 sub-shell is described by a line function, with *n_steps* sub-shells per
 interface. The form factor is normalized by the total volume of the sphere.
+
+.. note::
+
+   *n_shells* must be an integer. *n_steps* must be an ODD integer.
 
 Interface shapes are as follows:
@@ -73,5 +77,4 @@
     3 \rho_\text{solvent} V(r_N)
     \Big[ \frac{\sin(qr_N) - qr_N \cos(qr_N)} {qr_N^3} \Big]
-
 
 Here we assumed that the SLDs of the core and solvent are constant in $r$.
@@ -156,5 +159,4 @@
     \end{align*}
 
-
 We assume $\rho_{\text{inter}_j} (r)$ is approximately linear
 within the sub-shell $j$.
@@ -179,5 +181,4 @@
     when $P(Q) * S(Q)$ is applied.
 
-
 References
 ----------
@@ -194,9 +195,9 @@
 
 Authorship and Verification
-----------------------------
+---------------------------
 
 * **Author:** Jae-Hie Cho **Date:** Nov 1, 2010
 * **Last Modified by:** Paul Kienzle **Date:** Dec 20, 2016
-* **Last Reviewed by:** Paul Butler **Date:** September 8, 2018
+* **Last Reviewed by:** Steve King **Date:** March 29, 2019
 * **Source added by :** Steve King **Date:** March 25, 2019
 """
@@ -207,5 +208,5 @@
 
 name = "spherical_sld"
-title = "Sperical SLD intensity calculation"
+title = "Spherical SLD intensity calculation"
 description = """
             I(q) =
@@ -219,5 +220,5 @@
 # pylint: disable=bad-whitespace, line-too-long
 #            ["name", "units", default, [lower, upper], "type", "description"],
-parameters = [["n_shells",             "",           1,      [1, 10],        "volume", "number of shells"],
+parameters = [["n_shells",             "",           1,      [1, 10],        "volume", "number of shells (must be integer)"],
               ["sld_solvent",          "1e-6/Ang^2", 1.0,    [-inf, inf],    "sld", "solvent sld"],
               ["sld[n_shells]",        "1e-6/Ang^2", 4.06,   [-inf, inf],    "sld", "sld of the shell"],
@@ -232,5 +233,5 @@
 single = False  # TODO: fix low q behaviour
 have_Fq = True
-effective_radius_type = ["outer radius"]
+radius_effective_modes = ["outer radius"]
 
 profile_axes = ['Radius (A)', 'SLD (1e-6/A^2)']
Index: sasmodels/models/triaxial_ellipsoid.c
===================================================================
--- sasmodels/models/triaxial_ellipsoid.c	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/triaxial_ellipsoid.c	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -76,5 +76,5 @@
 
 static double
-effective_radius(int mode, double radius_equat_minor, double radius_equat_major, double radius_polar)
+radius_effective(int mode, double radius_equat_minor, double radius_equat_major, double radius_polar)
 {
     switch (mode) {
Index: sasmodels/models/triaxial_ellipsoid.py
===================================================================
--- sasmodels/models/triaxial_ellipsoid.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/triaxial_ellipsoid.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -164,5 +164,5 @@
 source = ["lib/sas_3j1x_x.c", "lib/gauss76.c", "triaxial_ellipsoid.c"]
 have_Fq = True
-effective_radius_type = [
+radius_effective_modes = [
     "equivalent biaxial ellipsoid average curvature",
     "equivalent volume sphere", "min radius", "max radius",
Index: sasmodels/models/unified_power_Rg.py
===================================================================
--- sasmodels/models/unified_power_Rg.py	(revision ef476e6b7ffc21ee7a467a47ef19a30527778450)
+++ sasmodels/models/unified_power_Rg.py	(revision ef476e6b7ffc21ee7a467a47ef19a30527778450)
@@ -0,0 +1,159 @@
+r"""
+Definition
+----------
+
+This model employs the empirical multiple level unified Exponential/Power-law
+fit method developed by Beaucage. Four functions are included so that 1, 2, 3,
+or 4 levels can be used. In addition a 0 level has been added which simply
+calculates
+
+.. math::
+
+    I(q) = \text{scale} / q + \text{background}
+
+The Beaucage method is able to reasonably approximate the scattering from
+many different types of particles, including fractal clusters, random coils
+(Debye equation), ellipsoidal particles, etc.
+
+The model works best for mass fractal systems characterized by Porod exponents
+between 5/3 and 3. It should not be used for surface fractal systems. Hammouda
+(2010) has pointed out a deficiency in the way this model handles the
+transitioning between the Guinier and Porod regimes and which can create
+artefacts that appear as kinks in the fitted model function.
+
+Also see the :ref:`guinier-porod` model.
+
+The empirical fit function is:
+
+.. math::
+
+    I(q) = \text{background}
+    + \sum_{i=1}^N \Bigl[
+        G_i \exp\Bigl(-\frac{q^2R_{gi}^2}{3}\Bigr)
+       + B_i \exp\Bigl(-\frac{q^2R_{g(i+1)}^2}{3}\Bigr)
+             \Bigl(\frac{1}{q_i^*}\Bigr)^{P_i} \Bigr]
+
+where
+
+.. math::
+
+    q_i^* = q \left[\operatorname{erf}
+            \left(\frac{q R_{gi}}{\sqrt{6}}\right)
+        \right]^{-3}
+
+
+For each level, the four parameters $G_i$, $R_{gi}$, $B_i$ and $P_i$ must
+be chosen.  Beaucage has an additional factor $k$ in the definition of
+$q_i^*$ which is ignored here.
+
+For example, to approximate the scattering from random coils (Debye equation),
+set $R_{gi}$ as the Guinier radius, $P_i = 2$, and $B_i = 2 G_i / R_{gi}$
+
+See the references for further information on choosing the parameters.
+
+For 2D data: The 2D scattering intensity is calculated in the same way as 1D,
+where the $q$ vector is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 + q_y^2}
+
+
+References
+----------
+
+.. [#] G Beaucage, *J. Appl. Cryst.*, 28 (1995) 717-728
+.. [#] G Beaucage, *J. Appl. Cryst.*, 29 (1996) 134-146
+.. [#] B Hammouda, *Analysis of the Beaucage model, J. Appl. Cryst.*, (2010), 43, 1474-1478
+
+Source
+------
+
+`unified_power_Rg.py <https://github.com/SasView/sasmodels/blob/master/sasmodels/models/unified_power_Rg.py>`_
+
+Authorship and Verification
+----------------------------
+
+* **Author:** 
+* **Last Modified by:** 
+* **Last Reviewed by:** 
+* **Source added by :** Steve King **Date:** March 25, 2019
+"""
+
+from __future__ import division
+
+import numpy as np
+from numpy import inf, exp, sqrt, errstate
+from scipy.special import erf, gamma
+
+category = "shape-independent"
+name = "unified_power_Rg"
+title = "Unified Power Rg"
+description = """
+        The Beaucage model employs the empirical multiple level unified
+        Exponential/Power-law fit method developed by G. Beaucage. Four functions
+        are included so that 1, 2, 3, or 4 levels can be used.
+        """
+
+# pylint: disable=bad-whitespace, line-too-long
+parameters = [
+    ["level",     "",     1,      [1, 6], "", "Level number"],
+    ["rg[level]", "Ang",  15.8,   [0, inf], "", "Radius of gyration"],
+    ["power[level]", "",  4,      [-inf, inf], "", "Power"],
+    ["B[level]",  "1/cm", 4.5e-6, [-inf, inf], "", ""],
+    ["G[level]",  "1/cm", 400,    [0, inf], "", ""],
+    ]
+# pylint: enable=bad-whitespace, line-too-long
+
+def Iq(q, level, rg, power, B, G):
+    """Return I(q) for unified power Rg model."""
+    level = int(level + 0.5)
+    if level == 0:
+        with errstate(divide='ignore'):
+            return 1./q
+
+    with errstate(divide='ignore', invalid='ignore'):
+        result = np.zeros(q.shape, 'd')
+        for i in range(level):
+            exp_now = exp(-(q*rg[i])**2/3.)
+            pow_now = (erf(q*rg[i]/sqrt(6.))**3/q)**power[i]
+            if i < level-1:
+                exp_next = exp(-(q*rg[i+1])**2/3.)
+            else:
+                exp_next = 1
+            result += G[i]*exp_now + B[i]*exp_next*pow_now
+
+    result[q == 0] = np.sum(G[:level])
+    return result
+
+Iq.vectorized = True
+
+def random():
+    """Return a random parameter set for the model."""
+    level = np.minimum(np.random.poisson(0.5) + 1, 6)
+    n = level
+    power = np.random.uniform(1.6, 3, n)
+    rg = 10**np.random.uniform(1, 5, n)
+    G = np.random.uniform(0.1, 10, n)**2 * 10**np.random.uniform(0.3, 3, n)
+    B = G * power / rg**power * gamma(power/2)
+    scale = 10**np.random.uniform(1, 4)
+    pars = dict(
+        #background=0,
+        scale=scale,
+        level=level,
+    )
+    pars.update(("power%d"%(k+1), v) for k, v in enumerate(power))
+    pars.update(("rg%d"%(k+1), v) for k, v in enumerate(rg))
+    pars.update(("B%d"%(k+1), v) for k, v in enumerate(B))
+    pars.update(("G%d"%(k+1), v) for k, v in enumerate(G))
+    return pars
+
+demo = dict(
+    level=2,
+    rg=[15.8, 21],
+    power=[4, 2],
+    B=[4.5e-6, 0.0006],
+    G=[400, 3],
+    scale=1.,
+    background=0.,
+)
Index: sasmodels/models/vesicle.c
===================================================================
--- sasmodels/models/vesicle.c	(revision 12f4c19f620b0845847bb04e53189f2c43808bac)
+++ sasmodels/models/vesicle.c	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -13,5 +13,5 @@
 
 static double
-effective_radius(int mode, double radius, double thickness)
+radius_effective(int mode, double radius, double thickness)
 {
     // case 1: outer radius
Index: sasmodels/models/vesicle.py
===================================================================
--- sasmodels/models/vesicle.py	(revision 0507e09b26f5789862db8a175d64657cf4f3b829)
+++ sasmodels/models/vesicle.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -107,5 +107,5 @@
 source = ["lib/sas_3j1x_x.c", "vesicle.c"]
 have_Fq = True
-effective_radius_type = ["outer radius"]
+radius_effective_modes = ["outer radius"]
 
 def random():
Index: sasmodels/product.py
===================================================================
--- sasmodels/product.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/product.py	(revision 8795b6f853cd54be29051109ba0e616e1b31b673)
@@ -31,10 +31,10 @@
 # pylint: enable=unused-import
 
-# TODO: make estimates available to constraints
+# TODO: make shape averages available to constraints
 #ESTIMATED_PARAMETERS = [
-#    ["est_radius_effective", "A", 0.0, [0, np.inf], "", "Estimated effective radius"],
-#    ["est_volume_ratio", "", 1.0, [0, np.inf], "", "Estimated volume ratio"],
+#    ["mean_radius_effective", "A", 0.0, [0, np.inf], "", "mean effective radius"],
+#    ["mean_volume", "A", 0.0, [0, np.inf], "", "mean volume"],
+#    ["mean_volume_ratio", "", 1.0, [0, np.inf], "", "mean form: mean shell volume ratio"],
 #]
-
 STRUCTURE_MODE_ID = "structure_factor_mode"
 RADIUS_MODE_ID = "radius_effective_mode"
@@ -44,5 +44,5 @@
     # type: (ModelInfo) -> List[Parameter]
     """
-    Create parameters for structure_factor_mode and radius_effective_mode.
+    Create parameters for structure factor and effective radius modes.
     """
     pars = []
@@ -56,10 +56,10 @@
             "Structure factor calculation")
         pars.append(par)
-    if p_info.effective_radius_type is not None:
+    if p_info.radius_effective_modes is not None:
         par = parse_parameter(
             RADIUS_MODE_ID,
             "",
             1,
-            [["unconstrained"] + p_info.effective_radius_type],
+            [["unconstrained"] + p_info.radius_effective_modes],
             "",
             "Effective radius calculation")
@@ -177,5 +177,5 @@
         S,                # type: np.ndarray
         scale,            # type: float
-        effective_radius, # type: float
+        radius_effective, # type: float
         beta_mode,        # type: bool
     ):
@@ -193,5 +193,5 @@
             ("beta(Q)", F1**2 / F2),
             ("S_eff(Q)", 1 + (F1**2 / F2)*(S-1)),
-            ("effective_radius", effective_radius),
+            ("effective_radius", radius_effective),
             # ("I(Q)", scale*(F2 + (F1**2)*(S-1)) + bg),
         ))
@@ -200,5 +200,5 @@
             ("P(Q)", scale*F2),
             ("S(Q)", S),
-            ("effective_radius", effective_radius),
+            ("effective_radius", radius_effective),
         ))
     return parts
@@ -281,6 +281,8 @@
         # R_eff type parameter is the second parameter after P and S parameters
         # unless the model doesn't support beta mode, in which case it is first
-        have_radius_type = p_info.effective_radius_type is not None
+        have_radius_type = p_info.radius_effective_modes is not None
+        #print(p_npars,s_npars)
         radius_type_offset = 2+p_npars+s_npars + (1 if have_beta_mode else 0)
+        #print(values[radius_type_offset])
         radius_type = int(values[radius_type_offset]) if have_radius_type else 0
 
@@ -331,5 +333,5 @@
         # Call the form factor kernel to compute <F> and <F^2>.
         # If the model doesn't support Fq the returned <F> will be None.
-        F1, F2, effective_radius, shell_volume, volume_ratio = self.p_kernel.Fq(
+        F1, F2, radius_effective, shell_volume, volume_ratio = self.p_kernel.Fq(
             p_details, p_values, cutoff, magnetic, radius_type)
 
@@ -341,8 +343,8 @@
         # implementation details in kernel_iq.c.
         #print("R_eff=%d:%g, volfrac=%g, volume ratio=%g"
-        #      % (radius_type, effective_radius, volfrac, volume_ratio))
+        #      % (radius_type, radius_effective, volfrac, volume_ratio))
         if radius_type > 0:
             # set the value to the model R_eff and set the weight to 1
-            s_values[2] = s_values[2+s_npars+s_offset[0]] = effective_radius
+            s_values[2] = s_values[2+s_npars+s_offset[0]] = radius_effective
             s_values[2+s_npars+s_offset[0]+nweights] = 1.0
         s_values[3] = s_values[2+s_npars+s_offset[1]] = volfrac*volume_ratio
@@ -370,5 +372,5 @@
         # the results directly rather than through a lazy evaluator.
         self.results = lambda: _intermediates(
-            F1, F2, S, combined_scale, effective_radius, beta_mode)
+            F1, F2, S, combined_scale, radius_effective, beta_mode)
 
         return final_result
Index: sasmodels/sasview_model.py
===================================================================
--- sasmodels/sasview_model.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
+++ sasmodels/sasview_model.py	(revision a34b8119b864fa10b972c2a11f92a9c5e13207f1)
@@ -299,5 +299,5 @@
     attrs['category'] = model_info.category
     attrs['is_structure_factor'] = model_info.structure_factor
-    attrs['is_form_factor'] = model_info.effective_radius_type is not None
+    attrs['is_form_factor'] = model_info.radius_effective_modes is not None
     attrs['is_multiplicity_model'] = variants[0] > 1
     attrs['multiplicity_info'] = variants
@@ -763,5 +763,5 @@
         #    if er_mode > 0:
         #        res = calculator.Fq(call_details, values, cutoff=self.cutoff,
-        #                            magnetic=False, effective_radius_type=mode)
+        #                            magnetic=False, radius_effective_mode=mode)
         #        R_eff, form_shell_ratio = res[2], res[4]
         #        return R_eff, form_shell_ratio
